var snagitScrollHelper = null;
var savePath = "";

// Listens for when the file is done saving
var snagitProgressListener = { 
stateIsRequest:false,
   QueryInterface : function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
         return this;
      throw Components.results.NS_NOINTERFACE;
   },
   onStateChange : function(aProgress,aRequest,aFlag,aStatus) {
      if( aFlag &  Components.interfaces.nsIWebProgressListener.STATE_STOP )
      {
          snagitScrollHelper.captureSaved( savePath );         
      }
      return 0;
   },
   
   onLocationChange    : function(aProgress,aRequest,aLocation) {return 0;},
   onProgressChange    : function(a,b,c,d,e,f){ },
   onStatusChange      : function(a,b,c,d){ },
   onSecurityChange    : function(a,b,c){ },
   onLinkIconAvailable : function(a){ } 
};


var snagitScroll = function () {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	return {
      // had to wait a tick before we initialized our scrollHelper with the current window. Not all of the interfaces
      // are set up right away onload.
      initdelay : function() {
         window.setTimeout( snagitScroll.init, 100 );
      },
		init : function () {
         
         // create XPCOM object for doing the communication with Snagit
         try
         {
            snagitScrollHelper = Components.classes['@techsmith.com/snagitscrollhelper;1'].createInstance(Components.interfaces.ISnagitScrollHelper);
            
            snagitScrollHelper.eventHandler = new nsSnagItEventHandler();
            
            // Tell the our XPCOM object what window to listen for events to
            // WARNING: unfrozen interfaces ahead. Will probably break :(
            requestor         = window.QueryInterface( Components.interfaces.nsIInterfaceRequestor );
            nav               = requestor.getInterface(Components.interfaces.nsIWebNavigation);
            docshelltreeitem  = nav.QueryInterface( Components.interfaces.nsIDocShellTreeItem);
            docshelltreeowner = docshelltreeitem.treeOwner;
            requestor         = docshelltreeowner.QueryInterface( Components.interfaces.nsIInterfaceRequestor );
            xulWindow         = requestor.getInterface( Components.interfaces.nsIXULWindow );
            docshell          = xulWindow.docShell;
            baseWindow        = docshell.QueryInterface( Components.interfaces.nsIBaseWindow );
            snagitScrollHelper.listenWithWindow( baseWindow );
         }
         catch (err)
         {
            alert(err);
         }
         
		},
      
      cleanup : function ()
      {
         snagitScrollHelper.eventHandler = null;
         snagitScrollHelper.stopListening();
         snagitScrollHelper = null;
      },
      
      doCapture : function () 
      {
         // Build a temp canvas:
         var canvas = content.document.createElementNS("http://www.w3.org/1999/xhtml", "html:canvas");
         var ctx = canvas.getContext("2d");
         
         var root = null, body = null;
         var height = 0, width = 0;
         
         // Try to get size from document
         root = content.document.documentElement;
         if ( root )
         {
            height = root.offsetHeight | root.scrollHeight;
            width = root.offsetWidth | root.scrollWidth;
         }
         // Sometimes only body has correct values:
         if (!height && (body = self.content.document.body)) {
            height = height | body.offsetHeight | body.scrollHeight;
         }
         
         canvas.height = height;
         canvas.width = width;
         
         ctx.clearRect(0, 0, canvas.width, canvas.height);
         ctx.save();
         ctx.drawWindow(content, 0, 0, width, height, "rgb(0,0,0)");
         ctx.restore();
         
         var ext = ".png", type = "image/png", data = null;
         
         data = canvas.toDataURL();
         
         var file = Components.classes["@mozilla.org/file/directory_service;1"]
                              .getService(Components.interfaces.nsIProperties)
                              .get("TmpD", Components.interfaces.nsIFile);
         
         file.append("snagitcap.png");
         file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
         
         
         // Save the file
         var persist = makeWebBrowserPersist();
         
         // set up persist flags.
         const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
         const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
         persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;
         
         // Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):
         persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
         persist.progressListener = snagitProgressListener;
         savePath = file.path;
         persist.saveURI(makeURI(data),null,null,null,null,file); 
		}
	};
}();

window.addEventListener("load", snagitScroll.initdelay, false);
window.addEventListener("unload", snagitScroll.cleanup, false);

/* Handles SnagIt events fired from XPCOM object */
function nsSnagItEventHandler() {
}

nsSnagItEventHandler.prototype = 
{
   StartCapture: function () {         
      snagitScroll.doCapture();
   },  
   QueryInterface: function (iid) {
      if (iid.equals(Components.interfaces.nsISnagItCaptureEvents) ||
          iid.equals(Components.interfaces.nsISupports))
         return this;
      
      throw Components.results.NS_ERROR_NO_INTERFACE;
   }
}



